<template>
  <div id="lecture_item_editor_wrapper">
    <h2>
      <div v-show="isNewItem">
        {{ $t('ITEM.ADD') }}
      </div>
      <div v-show="!isNewItem">
        {{ $t('LECTURE_MANAGE.EDIT_ITEM') }}
      </div>
    </h2>
    <el-form :model="inputHead" label-width="125px" style="max-width: 1000px;">
      <el-form-item :label="$t('ITEM.TYPE')" prop="order" id="lc_item_order">
        <el-radio-group v-model.number="inputHead.lcItemOrder">
          <el-radio-button :label="0">{{ $t('ITEM.PREV') }}</el-radio-button>
          <el-radio-button :label="1">{{ $t('ITEM.MAIN') }}</el-radio-button>
          <el-radio-button :label="2">{{ $t('ITEM.REV') }}</el-radio-button>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="$t('QUESTION.ITEM_TYPE')" prop="lcItemType" id="lc_item_type">
        <el-radio-group v-model="inputHead.lcItemType" :disabled="!isNewItem">
          <el-radio-button label="note">{{ $t('ITEM.NOTE') }}</el-radio-button>
          <el-radio-button label="question">{{ $t('ITEM.QUESTION') }}</el-radio-button>
          <el-radio-button label="survey">{{ $t('ITEM.SURVEY') }}</el-radio-button>
          <el-radio-button label="discussion">{{ $t('ITEM.DISCUSSION') }}</el-radio-button>
          <el-radio-button label="individualQuestion">{{ $t('ITEM.INDIV') }}</el-radio-button>
          <el-radio-button v-if="classType === 1" label="practice">{{ $t('PRACTICE.PRACT_ITEM') }}</el-radio-button>
          <el-radio-button v-if="classType === 1" label="coding">{{ $t('CODING.CODING_ASSIGN') }}</el-radio-button>
        </el-radio-group>

        <span v-show="!isNewItem">
          &nbsp; * {{ $t('QUESTION.DONT_EDIT') }}
        </span>
      </el-form-item>

      <el-form-item :label="$t('QUESTION.ITEM_NAME')" prop="lcItemName" id="lc_item_name">
        <div style="display: inline-block; width: 400px">
          <el-input v-model="inputHead.lcItemName" :placeholder="$t('QUESTION.ENTER_CON')"></el-input>
        </div>
      </el-form-item>

      <!-- choi -->
      <el-form-item v-show="['question', 'coding', 'individualQuestion'].includes(inputHead.lcItemType)" :label="$t('DUPLICATE.DUP_SUB_STTS')" prop="lcItemResult">
        <el-checkbox-group v-if="['question', 'individualQuestion'].includes(inputHead.lcItemType)" v-model="resultVisible" @change="oneItemCheck">
          <!--원래는 마지막에 :max='1'이 있었음. 수정을 위해서 :max='1'을 삭제함. -->
          <el-checkbox label="3" :disabled="checkboxDisable">{{ $t('DUPLICATE.DUP_SUB') }}</el-checkbox><br />
          <el-checkbox label="0" :disabled="checkboxDisable">{{ $t('DUPLICATE.DUP_SUB_NOT_DIS') }}</el-checkbox><br />
        </el-checkbox-group>
        <span v-show="['question', 'coding', 'individualQuestion'].includes(inputHead.lcItemType)">
          &nbsp; * {{ $t('DUPLICATE.DUP_SUB_DISP_SCREEN') }}
        </span>
      </el-form-item>

      <div v-show="!inputHead.lcItemType">
        <el-alert
          :title="$t('QUESTION.SLCT_QUES_TYPE')"
          :closable="false"
          type="warning"
          show-icon center>
        </el-alert>
        <br>
      </div>

      <!-- v-if를 쓰면 ref가 안 먹음 -->
      <lc-question-editor
        ref="questionEditor"
        v-show="inputHead.lcItemType === 'question'"
      />
      <lc-survey-editor
        ref="surveyEditor"
        v-show="inputHead.lcItemType === 'survey'"
      />
      <lc-practice-editor
        ref="practiceEditor"
        v-show="inputHead.lcItemType === 'practice'"
      />
      <lc-discussion-editor
        ref="discussionEditor"
        v-show="inputHead.lcItemType === 'discussion'"
      />
      <lc-note-editor
        ref="noteEditor"
        v-show="inputHead.lcItemType === 'note'"
      />
      <lc-coding-editor
        ref="codingEditor"
        v-show="inputHead.lcItemType === 'coding'"
      />
      <lc-individual-question-editor
        ref="individualQuestionEditor"
        v-show="inputHead.lcItemType === 'individualQuestion'"
        :isNewItem="isNewItem"
      />
      <template v-if="inputHead.lcItemType !== null && inputHead.lcItemType === 'survey'">
        <el-form-item 
          v-show="['DESCRIPTION'].includes(inputBody.surveyType)"
          :label="$t('QUESTION.LIMIT_LETTER_NUM')">
          <div style="display: inline-block; width: 400px">
            <el-radio-group v-model="selectLimitLength">
              <el-radio-button :label="$t('QUESTION.NO_LIMITED')"></el-radio-button>
              <el-radio-button :label="$t('QUESTION.LIMITED')"></el-radio-button>
            </el-radio-group>
          </div>
          <div v-if="selectLimitLength === $t('QUESTION.LIMITED')">
            <el-input 
              style="display: inline-block; width: 200px; margin-top:20px;"
              v-model.number="inputHead.lcItemLimitLength"
              :placeholder="$t('SURVEY.ENTER_NUM')">
            </el-input>
          </div>
        </el-form-item>
      </template>
      <template v-if="inputHead.lcItemType !== null && inputHead.lcItemType === 'discussion'">
        <el-form-item 
          :label="$t('QUESTION.LIMIT_LETTER_NUM')">
          <div style="display: inline-block; width: 400px">
            <el-radio-group v-model="selectLimitLength">
              <el-radio-button :label="$t('QUESTION.NO_LIMITED')"></el-radio-button>
              <el-radio-button :label="$t('QUESTION.LIMITED')"></el-radio-button>
            </el-radio-group>
          </div>
          <div v-if="selectLimitLength === $t('QUESTION.LIMITED')">
            <el-input
              style="display: inline-block; width: 200px; margin-top:20px;"
              v-model.number="inputHead.lcItemLimitLength"
              :placeholder="$t('SURVEY.ENTER_NUM')">
            </el-input>
          </div>
        </el-form-item>
      </template>
      <template v-if="inputHead.lcItemType !== null && inputHead.lcItemType === 'question'">
        <el-form-item 
          v-show="['SHORT_ANSWER','DESCRIPTION'].includes(inputBody.questionType)"
          :label="$t('QUESTION.LIMIT_LETTER_NUM')">
          <div style="display: inline-block; width: 400px">
            <el-radio-group v-model="selectLimitLength">
              <el-radio-button :label="$t('QUESTION.NO_LIMITED')"></el-radio-button>
              <el-radio-button :label="$t('QUESTION.LIMITED')"></el-radio-button>
            </el-radio-group>
          </div>
          <div v-if="selectLimitLength === $t('QUESTION.LIMITED')">
            <el-input
              style="display: inline-block; width: 200px; margin-top:20px;"
              v-model.number="inputHead.lcItemLimitLength"
              :placeholder="$t('SURVEY.ENTER_NUM')">
            </el-input>
          </div>
        </el-form-item>
      </template>
      <!-- TODO : '토론' 에도 키워드를 붙일때 조건 변경 -->
      <template v-if="inputHead.lcItemType !== null && !['discussion', 'individualQuestion'].includes(inputHead.lcItemType)">
          <!-- 수정 -->
          <el-button @click="centerDialogVisible = true">{{ $t('LECTURE_MANAGE.SLCT_KEY') }}</el-button>
           <el-dialog   
            :title="$t('LECTURE_MANAGE.SLCT_KEY')"
            :visible.sync="centerDialogVisible"
            width="40%"> 
            <div>
              <table id="table_design" :data="checkList">
                <thead>
                  <tr>
                    <td>{{ $t('KEYWORD.LEC_KEY') }}</td>
                    <td>{{ $t('LECTURE_MANAGE.ALLOTS') }}</td>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="(k, index) in keywordList" :key="index">
                    <td>
                      <el-input v-model="k.keyword" v-show="k.edit"></el-input>
                      <span v-show="!k.edit">{{ k.keyword }}</span>
                    </td>
                    <td>
                      <el-input-number  v-model="k.keywordPoint"  :controls=false ></el-input-number>
                    </td>
                  </tr>
                </tbody>
              </table>
              <el-button type="small" align = "right" style="margin: 0px 10px 0px 0px" @click="onClick('ADD_KEYWORD',centerDialogVisible=false)">{{ $t('LECTURE_MANAGE.ADD') }}</el-button>
            </div>
            </el-dialog><br>
          <div v-for="(item,index) in inputTail.assignedKeywordList" :key="item.keyword" style="display: inline-block;">
            <el-button>{{ item.keyword }} :: {{ item.score }} {{ $t('LECTURE_MANAGE.SCORE') }}</el-button>
            <el-button @click="onClick('DELETE_KEYWORD',index)" type="danger" style="margin: 0px 10px 0px 0px">X</el-button>
          </div>
          <br><br>
      </template>
    </el-form>

    <div class="ps-align-right" id="lecture_item_editor_submit_button_wrapper">
      <el-button @click="onClick('CANCEL_EDIT')">{{ $t('BOARD.CANCEL') }}</el-button>
      <el-button type="primary" v-show="isNewItem" @click="onSubmit">{{ $t('LECTURE_MANAGE.ADD') }}</el-button>
      <el-button type="primary" v-show="!isNewItem" @click="onSubmit">{{ $t('BOARD.EDIT') }}</el-button>
    </div>
  </div>
</template>

<script>
import { mapActions, mapMutations, mapGetters, mapState } from 'vuex';
import { isNullOrUndefined } from 'util';

import classService from '../../services/classService';

import LcQuestionEditor from './LcQuestionEditor';
import LcSurveyEditor from './LcSurveyEditor';
import LcDiscussionEditor from './LcDiscussionEditor';
import LcPracticeEditor from './LcPracticeEditor';
import LcNoteEditor from './LcNoteEditor';
import LcCodingEditor from './LcCodingEditor';
import LcIndividualQuestionEditor from './LcIndividualQuestionEditor';

import QuestionHandler from '../../handlers/lcItem/question';
import PracticeHandler from '../../handlers/lcItem/practice';
import DiscussionHandler from '../../handlers/lcItem/discussion';
import SurveyHandler from '../../handlers/lcItem/survey';
import NoteHandler from '../../handlers/lcItem/note';
import IndividualQuestionHandler from '../../handlers/lcItem/individualQuestion';
import utils from '../../utils';

export default {
  name: 'LectureItemEditor',
  components: {
    LcQuestionEditor,
    LcSurveyEditor,
    LcDiscussionEditor,
    LcPracticeEditor,
    LcNoteEditor,
    LcCodingEditor,
    LcIndividualQuestionEditor,
  },
  props: ['numOfLectureItem'],
  async mounted() {
    const vm = this;

    //keywordPoint 0으로 초기화
    vm.keywordList.forEach((x) =>{
      x.keywordPoint = 0;
    });    

    // 일반 과목인지 실습 과목인지 확인 190705
    const classId = Number.parseInt(vm.$route.query.classId, 10);
    const classInfo = await classService.getClass({
      id: classId,
    });
    vm.classType = classInfo.data.practice; // 0은 일반과목, 1은 실습과목

    await vm.getLecture({ lectureId: vm.lectureId });
    
    if (!vm.isNewItem) {
      await vm.getLcItem();
      const item = vm.lectureItem;

      vm.inputHead.lcItemOrder = item.order;
      vm.inputHead.lcItemType = utils.convertLcItemType(item.type);
      vm.inputHead.lcItemName = item.name;
      vm.inputHead.lcItemResult = item.result;
      vm.inputHead.lcItemLimitLength = item.limit_length;
      vm.resultVisible.push(item.result.toString());

      if (vm.inputHead.lcItemLimitLength === null) {
        vm.selectLimitLength = '제한 없음';
      } else {
        vm.selectLimitLength = '제한 있음';
      }
      /*
      const offset = new Date(2018, 8, 15, 0, 0, 0);
      offset.setSeconds(item.offset);
      vm.inputHead.lcItemOffset = offset;
      */

      // * Init inputBody, tail
      switch (vm.inputHead.lcItemType) {
        case 'question': {
          QuestionHandler.initViewModel(vm);
          break;
        }
        case 'practice': {
          PracticeHandler.initViewModel(vm);
          break;
        }
        case 'survey': {
          SurveyHandler.initViewModel(vm);
          break;
        }
        case 'discussion': {
          DiscussionHandler.initViewModel(vm);
          break;
        }
        case 'note': {
          NoteHandler.initViewModel(vm);
          break;
        }
        case 'coding': {
          PracticeHandler.initViewModel(vm);
          // CodingHandler.initViewModel(vm);
          break;
        }
        case 'individualQuestion': {
          IndividualQuestionHandler.initViewModel(vm);
          break;
        }
        default: {
          throw new Error(`not defined lcItemType ${vm.inputHead.lcItemType}`);
        }
      }
    }

    // 유인에서만 답안 공개 가능하도록 수정
    if (vm.lecture.type !== 0) {
      vm.checkboxDisable = true;
      vm.resultVisible = ['0'];
      vm.inputHead.lcItemResult = 0;
    }

  },
  data() {
    const vm = this;
    const initialInputHead = {
      lcItemOrder: 1,
      lcItemName: null,
      lcItemType: null,
      lcItemSequence: vm.numOfLectureItem + 1,
      lcItemResult: null,
      lcItemOffset: null,
      lcItemLimitLength: null,
    };
    return {
      classType: null,
      initialInputHead,
      centerDialogVisible: false,
      checkList: [],
      checkboxDisable: false,
      inputHead: Object.assign({}, initialInputHead),
      selectOptionList: [{
        value: 'question',
        label: this.$t('ITEM.QUESTION'),
      }, {
        value: 'survey',
        label: this.$t('ITEM.SURVEY'),
      }, {
        value: 'practice',
        label: this.$t('PRACTICE.PRACT_ITEM'),
      }, {
        value: 'discussion',
        label: this.$t('ITEM.DISCUSSION'),
      }, {
        value: 'note',
        label: this.$t('ITEM.NOTE'),
      }, {
        value: 'coding',
        label: this.$t('CODING.CODING_ASSIGN'),
      }, {
        value: 'individualQuestion',
        label: this.$t('ITEM.INDIV'),
      },
      ],
      resultVisible: [], // 결과 공개 여부 0:비공개, 1:공개, 2:비공개(중복 제출 불가), 3:공개, 답안은 아이템 내릴때 보임 (기존 1, 2는 비활성화 하고 3으로 대체)
      selectLimitLength: '제한 없음',
    };
  },
  computed: {
    ...mapState('lc', [
      'lecture',
    ]),
    ...mapState('lcItem', [
      'lectureItem',
    ]),
    ...mapGetters('lcItem', [
      'isNewItem',
    ]),
    ...mapState('keyword', [
      'keywordList',
    ]),
    inputBody() {
      const vm = this;
      const lcItemType = vm.inputHead.lcItemType;
      if (!lcItemType) {
        return null;
      }
      return vm.$refs[`${lcItemType}Editor`].inputBody;
    },
    inputTail() {
      const vm = this;
      const lcItemType = vm.inputHead.lcItemType;
      if (!lcItemType) {
        return null;
      }
      return vm.$refs[`${lcItemType}Editor`].inputTail;
    },
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
    modifiedKeywordList() {
      const vm = this;
      return vm.keywordList.map(x => ({ value: x.keyword }));
    },
  },
  methods: {
    ...mapActions('lc', [
      'getLecture',
    ]),
    ...mapMutations('lcItem', [
      'updateCurrentEditingLectureItemId',
      'updateLectureItem',
    ]),
    ...mapActions('lcItem', [
      'getLcItem',
      'postLcItem',
      'putLcItem',
    ]),
    reset() {
      const vm = this;
      vm.updateCurrentEditingLectureItemId({
        currentEditingLectureItemId: null,
      });
      vm.updateLectureItem({
        lectureItem: null,
      });
      const lcItemType = vm.inputHead.lcItemType;
      vm.$refs[`${lcItemType}Editor`].reset();
      vm.inputHead = Object.assign({}, vm.initialInputHead);
    },
    querySearch(queryString, cb) {
      const vm = this;
      const results = queryString ?
        vm.modifiedKeywordList.filter(vm.createFilter(queryString)) : vm.modifiedKeywordList;
      // call callback function to return suggestions
      cb(results);
    },
    createFilter(queryString) { // eslint-disable-next-line
      return (link) => {
        return (link.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
      };
    },
    onClick(type, arg) {
      const vm = this;

      switch (type) {
        case 'CANCEL_EDIT': {
          vm.updateCurrentEditingLectureItemId({
            currentEditingLectureItemId: null,
          });
          break;
        }
        case 'ADD_KEYWORD': {
          //수정
            if(vm.keywordList.length>vm.checkList.length){
             for(let i=0; i<vm.keywordList.length;i++){
              vm.checkList.push(0);
              if(vm.checkList.length===vm.keywordList.length){break;}}}

              if(vm.keywordList.length!==0){
                for(let i=0; i<vm.keywordList.length;i++){
                  if(vm.keywordList[i].keywordPoint>=0){
                  if(vm.keywordList[i].keywordPoint!==""){vm.checkList[i]=1;}
               }}}

                for(let i=0; i<vm.keywordList.length;i++){
                  if(vm.keywordList[i].keywordPoint===""||vm.keywordList[i].keywordPoint===null||vm.keywordList[i].keywordPoint===0){vm.checkList[i]=0;}
                }       
                   
              for(let i=0; i<vm.keywordList.length; i++)// eslint-disable-line
             {
              if(vm.keywordList[i].keywordPoint!==null&&vm.keywordList[i].keywordPoint!==""&& vm.keywordList[i].keywordPoint!==0 && (vm.keywordList[i].keywordPoint>100 || vm.keywordList[i].keywordPoint<1)){// eslint-disable-line
                vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.BETWEEN_ONE_HUND'),
                type: 'warning',
                });
                return;}
              if(typeof vm.keywordList[i].keywordPoint!=="number"){
                vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.BETWEEN_ONE_HUND'),
                type: 'warning',});
                return;
              }}

            let check_1=0;
          for(let i=0; i<vm.checkList.length;i++){// eslint-disable-line
            check_1=0;
            if(vm.checkList[i]===1){
              for(let j=0; j<vm.inputTail.assignedKeywordList.length;j++){
                if(vm.keywordList[i].keyword===vm.inputTail.assignedKeywordList[j].keyword){
                  vm.inputTail.assignedKeywordList[j].score=vm.keywordList[i].keywordPoint;

                  check_1=1;
                  break;}}
              if(check_1===0){
                vm.inputTail.assignedKeywordList.push({
                        keyword:vm.keywordList[i].keyword,
                        score:vm.keywordList[i].keywordPoint
                      });}}}
          for(let i=0; i<vm.keywordList.length;i++){
            vm.keywordList[i].keywordPoint = 0;
          }
          break;
        }
        case 'DELETE_KEYWORD': {
         for(let i=0; i<vm.keywordList.length;i++){
            if(vm.inputTail.assignedKeywordList[arg].keyword===vm.keywordList[i].keyword){
              vm.keywordList[i].keywordPoint=0;
            }}
          vm.inputTail.assignedKeywordList.splice(arg, 1);
          break;
        }
        case 'ADD_TEST_CASE': {
          vm.inputTail.testCaseList.push({
            input: '',
            output: '',
          });
          break;
        }
        case 'DELETE_TEST_CASE': {
          vm.inputTail.testCaseList.splice(arg, 1);
          break;
        }
        default : {
          break;
        }
      }
    },
    // 한 선택지만 체크 가능
    oneItemCheck() {
      const vm = this;
      if (vm.resultVisible.length === 2) {
        vm.resultVisible.splice(0, 1);
      }
      // integer 값 넣기
      vm.inputHead.lcItemResult = parseInt(vm.resultVisible[0], 10);
    },
    async onSubmit() {
      const vm = this;
      if(vm.inputHead.lcItemType === 'survey') // 설문이면 무조건 중복제출
        vm.resultVisible[0] = 1;

      // FIXME : 이전 단계에서 하고싶지만, 방법을 찾지 못해서 여기서 변환합니다. 혹시 찾는다면 이 부분을 제거하고, 상위 단계에서 진행해주세요.
        // 3가지 경우를 모두 생각해야 함
          // 1. 파일이 새로 올라온 경우 - multiChoiceMedia[i]에 ...uploadFiles[0].raw를 넣는다. (이후 서버에 전송하고 multichoiceMedia에는 guid를 넣는다.) // eslint-disable-line
          // 2. 원래 있었는데, 삭제된 경우 - multiChoiceMedia[i]에 undefined를 넣는다. (이후 서버에 전송한다.) // eslint-disable-line
          // 3. 원래 없던 경우 - multichoiceMedia[i]는 비어있는 상태 (이후 서버에 전송한다.)
      // 문항 - 객관 - 멀티미디어 - 이미지 일때, 파일.raw를 inputTail.multiChoiceMedia[] 으로 복사
      if (vm.inputHead.lcItemType === 'question' && ['MULTIPLE_CHOICE', 'CONNECTION'].includes(vm.inputBody.questionType)) {
        if (vm.inputTail.multiChoiceMediaType === 'image') {
          for (let i = 0; i < 5; i += 1) { // 파일이 있으면, 파일을 inputTail배열로 옮김
            eval( // eslint-disable-line
              `if (vm.$refs.questionEditor.$refs.MultiChoiceUpload${i}[0].uploadFiles.length === 1
                && vm.$refs.questionEditor.$refs.MultiChoiceUpload${i}[0].uploadFiles[0].raw !== undefined) { // 새로 올린 파일이 있을때만 발동
                  vm.inputTail.multiChoiceMedia[${i}] = vm.$refs.questionEditor.$refs.MultiChoiceUpload${i}[0].uploadFiles[0].raw;
                  vm.inputTail.questionList[${i}] = 'temp'; // 유효성 검사용
                } else if (vm.$refs.questionEditor.$refs.MultiChoiceUpload${i}[0].uploadFiles.length === 0) { // 새로 올린 파일이 없고, 기존에 올린 파일을 지웠을 때
                  vm.inputTail.multiChoiceMedia[${i}] = undefined;
                }
              `,
            );
          }
        }
        if (vm.inputTail.multiChoiceMediaType === 'voice') {
          for (let i = 0; i < vm.inputTail.multiChoiceMedia.length; i += 1) {
            if (vm.inputTail.multiChoiceMedia[i] !== undefined) {
              vm.inputTail.questionList[i] = 'temp'; // 유효성 검사 통과용
            }
          }
        }
      }

      // ***** 유효성 검사 *****
      // 자료,문항,실습은 키워드가 없다면 알람을 띄우고 막음
      if (vm.inputHead.lcItemType === 'question' ||
          vm.inputHead.lcItemType === 'note' ||
          vm.inputHead.lcItemType === 'practice' ||
          vm.inputHead.lcItemType === 'coding') {
        if (vm.inputTail.assignedKeywordList === undefined ||
          vm.inputTail.assignedKeywordList.length === 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.NEED_ONE_PAIR'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }
      vm.inputHead.lcItemOffset = null;

      // 문항 - 단답에 답이 없으면 제출 불가
      if (vm.inputBody.questionType === 'SHORT_ANSWER' &&
        vm.inputTail.answer[0] === '') {
        vm.$notify({
          title: vm.$t('NOTIFY.CRE_FAIL'),
          message: vm.$t('NOTIFY.ENTER_ANS'),
          type: 'error',
          duration: 5000,
        });
        return;
      }
      // 문항 - 객관에 답이 없으면 제출 불가
      if (vm.inputBody.questionType === 'MULTIPLE_CHOICE' &&
        vm.inputTail.answer.length === 0) {
        vm.$notify({
          title: vm.$t('NOTIFY.CRE_FAIL'),
          message: vm.$t('NOTIFY.SLCT_MORE_ONE'),
          type: 'error',
          duration: 5000,
        });
        return;
      }

      // 보기가 하나도 없는 객관식 문항은 생성 불가
      if (vm.inputHead.lcItemType === 'question' &&
      vm.inputBody.questionType === 'MULTIPLE_CHOICE' &&
      (vm.inputTail.questionList[0] === undefined || vm.inputTail.questionList[0] === '') &&
      (vm.inputTail.questionList[1] === undefined || vm.inputTail.questionList[1] === '') &&
      (vm.inputTail.questionList[2] === undefined || vm.inputTail.questionList[2] === '') &&
      (vm.inputTail.questionList[3] === undefined || vm.inputTail.questionList[3] === '') &&
      (vm.inputTail.questionList[4] === undefined || vm.inputTail.questionList[4] === '')) {
        vm.$notify({
          title: vm.$t('NOTIFY.CRE_FAIL'),
          message: vm.$t('NOTIFY.MUST_ENTER_CHOI'),
          type: 'error',
          duration: 5000,
        });
        return;
      }

      // 문항 단답형 - answer가 비어있으면 안 됨 190328
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'SHORT_ANSWER') {
        let blank = false;
        vm.inputTail.answer.forEach((x) => {
          if (x === '') {
            blank = true;
          }
        });
        if (blank === true) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.NOT_ENTER_ANS'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 문항 객관식 - 비어있는 보기가 있으면 안 됨
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'MULTIPLE_CHOICE') {
        let blank = false;
        for (let i = 0; i < vm.inputTail.questionList.length; i += 1) {
          const x = vm.inputTail.questionList[i];
          // 아예 empty거나 입력했다가 답을 지운 경우
          if (isNullOrUndefined(x) || x === '') {
            blank = true;
          }
        }
        if (blank === true) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.FILL_BLANKS'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 문항 객관식 - 정답 보기를 반드시 선택해야 함
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'MULTIPLE_CHOICE') {
        if (vm.inputTail.answer.length === 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.NOT_SLCT_ANS'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 문항 - 중복 제출 여부 선택해야 함
      if (vm.inputHead.lcItemType === 'question' || vm.inputHead.lcItemType === 'individualQuestion') {
        if (vm.inputHead.lcItemResult === null || vm.inputHead.lcItemResult === undefined) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.SLCT_OPEN_CLOSE'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 설문, 코딩과제 - 중복 제출 여부 선택해야 함 -> 설문은 무조건 중복제출이므로 삭제함
      if (vm.inputHead.lcItemType === 'coding') {
        if (vm.inputHead.lcItemResult === null || vm.inputHead.lcItemResult === undefined ||
            vm.inputHead.lcItemResult === 2) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.SLCT_OPEN_CLOSE'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 문항 - 멀티미디어: 답안 형식 설정해야함
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'MULTIMEDIA') {
        if (vm.inputTail.answerMediaType === 'none') {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.ASGN_ANS_FORMAT'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }
      // 개인화 문항 유효성 검사
      // 개인화 문항이고 하나이상의 group data가 있으면
      if (vm.inputBody.individualType === true
      && vm.inputTail.groupDataList.groupInfoList.length === 0) {
        vm.$notify({
          title: vm.$t('ITEM.CREATE_FAIL'),
          message: vm.$t('ITEM.CREATE_FAIL_MSG'),
          type: 'error',
          duration: 5000,
        });
        return;
      }
      // 문항 - 연결형: 양쪽 보기가 중간에 비어있거나 왼쪽 보기가 모두 선택되지 않은 경우 return
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'CONNECTION') {
        let tempQuestionList = [];
        let tempChoice2 = [];
        let tempAnswer = [];
        for (let k = 0; k < 5; k++) { //eslint-disable-line
          if (vm.inputTail.questionList[4-k] !== undefined && vm.inputTail.questionList[4-k].length > 0) {
            tempQuestionList[4-k] = vm.inputTail.questionList[4-k];
          }
          if (vm.inputTail.choice2[4-k] !== undefined && vm.inputTail.choice2[4-k].length > 0) {
            tempChoice2[4-k] = vm.inputTail.choice2[4-k];
          }
          if (vm.inputTail.answer[4-k] !== undefined && vm.inputTail.answer[4-k] !== null && vm.inputTail.answer[4-k] > 5 && vm.inputTail.answer[4-k] < 11) {
            tempAnswer[4-k] = vm.inputTail.answer[4-k];
          }
        }
        vm.inputTail.questionList = tempQuestionList;
        vm.inputTail.choice2 = tempChoice2;
        vm.inputTail.answer = tempAnswer;
        if (vm.inputTail.questionList.filter(question => question.length > 0).length !== vm.inputTail.questionList.length
          || vm.inputTail.choice2.filter(choice => choice.length > 0).length !== vm.inputTail.choice2.length) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.CONNECTION_CONTENT_INCOMPLETE'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
        if (vm.inputTail.answer.filter(answer => answer > 5 && answer < 11).length !== vm.inputTail.answer.length || vm.inputTail.answer.length !== vm.inputTail.questionList.length || vm.inputTail.answer.filter(answer => answer > vm.inputTail.choice2.length + 5).length > 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.CONNECTION_CHOICE_INCOMPLETE'),
            type: 'error',
            duration: 5000,
          });
          return;
        }
      }

      // 문항 - 키워드의 배점 제한(1~100점)
      if (vm.inputHead.lcItemType === 'question') {
        let flag = false;
        vm.inputTail.assignedKeywordList.forEach((x) => {
          const score = Number(x.score);
          if(!(x.score >= 1 && x.score <= 100)) {
            vm.$notify({
              title: vm.$t('NOTIFY.FAIL_MODIFY'),
              message: vm.$t('NOTIFY.ALLOTS_LIMIT'),
              type: 'error',
            });
            flag = true;
          }
        });
        if(flag) {
          return;
        }
      }

      // 문항(단답, 서술), 설문, 토론 - 글자 수 제한(1~999숫자만)
      // 입력값이 숫자가 아닐 경우 또는 1과 999 사이의 숫자가 아닌 경우
      if ((vm.inputHead.lcItemLimitLength !== null && typeof vm.inputHead.lcItemLimitLength !== 'number')
      || (typeof vm.inputHead.lcItemLimitLength === 'number' && (vm.inputHead.lcItemLimitLength <= 0 || vm.inputHead.lcItemLimitLength >= 1000))) {        
        vm.$notify({
          title: vm.$t('NOTIFY.CRE_FAIL'),
          message: vm.$t('NOTIFY.LEN_LIMIT_VALID_NUM'),
          type: 'error',
          duration: 5000,
        });
        return;          
      }

      // SW 문항일 경우
      if (vm.inputHead.lcItemType === 'question' && vm.inputBody.questionType === 'SW') {
        // 테스트 케이스가 없을 경우
        if (vm.inputTail.testCaseList.length === 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.TESTCASES_NEED'),
            type: 'warning',
            duration: 5000,
          });
          return;
        }
        // 시간 제한이 음수일 경우
        if (vm.inputTail.timeLimit <= 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.TIMELIMIT_POSITIVE'),
            type: 'warning',
            duration: 5000,
          });
          return;
        }
        // 메모리 제한이 음수일 경우
        if (vm.inputTail.memoryLimit <= 0) {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.MEMORYLIMIT_POSITIVE'),
            type: 'warning',
            duration: 5000,
          });
          return;
        }
        // 문항 내용이 비어있을 경우
        if (vm.inputTail.question === '') {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.QUESTION_NEED'),
            type: 'warning',
            duration: 5000,
          });
          return;
        }
        // 언어가 선택되지 않았을 경우 
        if (vm.inputTail.language === '') {
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: vm.$t('NOTIFY.LANGUAGE_NEED'),
            type: 'warning',
            duration: 5000,
          });
          return;
        }
      }

      // ***** 유효성 검사 끝 *****
      if (vm.isNewItem) {
        try {
          // 아이템 만들기
          await vm.postLcItem({
            inputHead: vm.inputHead,
            inputBody: vm.inputBody,
            inputTail: vm.inputTail,
          });
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_COMP'),
            message: vm.$t('NOTIFY.ITEM_CRE'),
            type: 'success',
          });

          vm.reset();

          await vm.getLecture({ lectureId: vm.lectureId }); // lecture item list 업데이트
        } catch (error) {
          console.log(error);
          vm.$notify({
            title: vm.$t('NOTIFY.CRE_FAIL'),
            message: error.toString(),
            type: 'error',
            duration: 0,
          });
        }
      } else {
        try {
          await vm.putLcItem({
            inputHead: vm.inputHead,
            inputBody: vm.inputBody,
            inputTail: vm.inputTail,
          });
          vm.$notify({
            title: vm.$t('NOTIFY.COMP_MODIFY'),
            message: vm.$t('NOTIFY.SUC_MODI_COMP'),
            type: 'success',
          });

          vm.reset();

          await vm.getLecture({ lectureId: vm.lectureId }); // lecture item list 업데이트
        } catch (error) {
          vm.$notify({
            title: vm.$t('NOTIFY.FAIL_MODIFY'),
            message: error.toString(),
            type: 'error',
            duration: 0,
          });
          console.error(error); // eslint-disable-line
        }
      }
    },
  },
};
</script>
